100 REMark Just to remind one why 'C' is so nice and *BASIC sucks,
110 REMark here is a little trivial *BASIC example of how to monitor
120 REMark the serial port and answer fax or data calls.
130 :
140 REMark This works 'just fine' on a 68008 QL/Minerva/Hermes with
150 REMark ZyXEL 1496+ modem or a direct NULL modem cable to an
160 REMark Amiga 3000. Guess that means it won't work on anything else.
170 :
180 REMark *BASIC ? Structured ?? Or just a bad joke ???
190 :
200 Main
210 STOP
220 :
230 REMark resp$ = ModemResp$(#channel, timeout%)
240 REMark attempts to read a modem response on #channel within timeout%
250 REMark seconds (or -1 forever).
260 :
270 REMark Returns resp$ = "-1" for timeout. Blank lines (CR/LF) are skipped.
280 REMark Returns resp$ = "-2" for CSM QUIT.
290 :
300 DEFine FuNction ModemResp$(ch, timo)
310 LOCal a$,resp$,srv$
320 LOCal first%,term%,mwait%,twait%
330 LOCal loop,ctx
340 first% = 1
350 term% = 10
360 resp$ = ""
370 IF timo > 0 THEN
380  twait% = timo * 50
390  mwait% = 5
400 ELSE
410  mwait% = 50
420  twait% = -1
430 END IF
440 REPeat loop
450  a$ = INKEY$ (#ch, mwait%)
460  ch% = CODE(a$)
470  IF ch% = 0 THEN
480   IF twait% <> -1 THEN
490    twait% = twait% - mwait%
500    IF twait% = 0 THEN
510     resp$ = "-1"
520     EXIT loop
530    END IF
540   END IF
550   ctx = SRVPOLL('SER_MON', srv$, 0)
560   IF ctx >= 0 THEN
570    IF srv$ == 'quit' : resp$ = "-2"
580    IF ctx > 0 THEN
590     IF resp$ = "-2" THEN
600      SRVREPLY ctx,"OK"
610     ELSE
620      SRVREPLY ctx,"ERROR"
630     END IF
640    END IF
650    IF resp$ = "-2" : EXIT loop
660   END IF
670  ELSE
680   IF first% = 1 THEN
690    IF a$ == 'A'
700     term% = 13
710    END IF
720    first% = 0
730   END IF
740   IF ch% = term% THEN
750    IF resp$ = "" THEN
760     first% = 1 :  term% = 10 : NEXT loop
770    ELSE
780     EXIT loop
790    END IF
800   END IF
810   IF ch% > 31 : resp$ = resp$ & a$
820  END IF
830 END REPeat loop
840 RETurn resp$
850 END DEFine
860 :
870 REMark res% = ModemIni(ch, wait$)
880 REMark Initialises the modem on channel #ch. Wait$ is a string of terminal
890 REMark responses. Returns 0 if "OK".
900 :
910 DEFine FuNction ModemIni(ch,wait$)
920 LOCal loop
930 LOCal a$,b$
940 LOCal retval%
950 retval% = 0
960 DATA "ATZ","AT+FCLASS=2"
970 DATA "ATS38.3=1 +FAA=1 +FCR=1 +FLID=1489-895765", ""
980 RESTORE
990 REPeat loop
1000  READ a$
1010  IF a$ = "" : EXIT loop
1020  PRINT a$
1030  PRINT #ch,a$;CHR$(13);
1040  REPeat mloop
1050   b$ = ModemResp$ (#ch, 10)
1060   IF b$ INSTR wait$ : EXIT mloop
1070  END REPeat mloop
1080  PRINT b$
1090  IF b$ = "-1" THEN
1100   retval% = -1
1110   EXIT loop
1120  END IF
1130  IF b$ = "-2" THEN
1140   retval% = -10
1150   EXIT loop
1160  END IF
1170  IF b$ <> "OK" THEN
1180   retval% = -13
1190   EXIT loop
1200  END IF
1210 END REPeat loop
1220 RETurn retval%
1230 END DEFine
1240 :
1250 DEFine PROCedure CleanUp (ch)
1260  IF ch > 0 : CLOSE #ch
1270  FREESERVER 'SER_MON'
1280 END DEFine
1290 :
1300 DEFine PROCedure Main
1310 LOCal mloop,loop,ch
1320 LOCal ring$, conn$
1330 LOCal a%
1340 SERVER 'SER_MON'
1350 baud 19200
1360 ch = FOPEN(ser1hr)
1370 IF ch > 0 THEN
1380  REPeat loop
1390   a% = ModemIni (#ch, "OKERROR-1")
1400   IF a% = 0 THEN
1410    PRINT "Waiting on Call"
1420    ring$ = ModemResp$(#ch, -1)
1430    IF ring$ == "RING" THEN
1440     PRINT #ch,"ATA";CHR$(13);
1450     REPeat mloop
1460      conn$ = ModemResp$ (#ch, 60)
1470      IF conn$ == "-1" : PRINT "Timeout" : EXIT mloop
1480      IF conn$ == "-2" : PRINT "Server exit" : EXIT loop
1490      IF "CONNECT" INSTR conn$ THEN
1500       IF "FAX" INSTR conn$ THEN
1510        EW win1_fax_qfax,#ch,#1,#1;'-v -G'
1520       ELSE
1530        EW win1_mbx_smbx,#ch,#1,#ch
1540       END IF
1550       EXIT mloop
1560      END IF
1570     END REPeat mloop
1580    ELSE
1590     IF ring$ == "-2" : PRINT "Server exit" : EXIT loop
1600    END IF
1610   ELSE
1620    PRINT "Modem init fails"
1630    EXIT loop
1640   END IF
1650  END REPeat loop
1660 ELSE
1670  PRINT "Can't open serial port : ";
1680  REPORT #1,ch
1690 END IF
1700 CleanUp #ch
1710 END DEFine
